<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 3.0.10  
* Copyright (C) 2007-2013: Fred Stuurman (fc.stuurman@gmail.com)
* class pages module : 
* studenteditor.php: last changed 20/01/2013 by Fred Stuurman (fc.stuurman@gmail.com)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/

define('IN_SAS', true);

include ("../../configuration/database.inc.php"); // connecting to database
$db = new mysqli($db_server, $db_username, $db_password, $db_name);

require ("../../core/session.php"); //build a session
include ("../../core/common.inc.php"); //include common functions

$check_sessioncode = "";
$query = "SELECT config_value FROM $table_configuration WHERE config_key = 'sessioncode'";
if ($result = mysqli_query($db,$query))
{
	$check_sessioncode = mysqli_result($result, 0);
	unset ($query);
	unset ($result);
}

if ($_SESSION['sessioncode'] != $check_sessioncode)
{
	//if we don't have a session present the login screen
	Header("Location: ../../../index.php");
	exit;
}
else
{
	$edit_page = 0;
	if (IsSet ($_GET['editpage']))
	{
		$edit_page = intval($_GET['editpage']);
		//check to see if the page we edit is in the authorized pages list
		$auth_array = explode(",", $_SESSION['pages_authorized']) ;
		if((!in_array($edit_page, $auth_array)))
		{
			exit;
		}
	}
	elseif (IsSet ($_GET['save_page']))
	{
		$save_page = intval($_GET['save_page']);
		//check to see if the page we save is in the authorized pages list
		$auth_array = explode(",", $_SESSION['pages_authorized']) ;
		if((!in_array($save_page, $auth_array)))
		{
			exit;
		}
	}
	else
	{
		exit;	//nothing to do exit here.
	}
	
	$query = "SELECT config_key,config_value FROM $table_configuration";
	//read all the configuration items
	$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING); 
	while ($config_list = mysqli_fetch_array($result))
	{
		$sas_config[$config_list[0]] = $config_list[1];
		//put them in the config array
	}
	
	$sas_language = $sas_config['language'];
	unset ($sas_lang);	//just to be sure
	include ("../../languages/$sas_language/$sas_language.php");

	$query = "SELECT name, project, class, email FROM $table_users WHERE id = '".$_SESSION['userid']."'"; // getting the studentname
	$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING); 
	$student_name = mysqli_result($result, 0, 'name');
	$student_project = mysqli_result($result, 0, 'project');
	$class = mysqli_result($result, 0, 'class');
	$student_email = mysqli_result($result, 0, 'email');
	
	if($student_project == "")
	{
		$project_array[0] = "-" ; //set dummy projectid
	}
	else
	{
		$project_array = explode(",", $student_project); //create an array
	}

	unset ($query);
	unset ($result);

	if (IsSet ($save_page))
	{
		if (IsSet ($_POST['title']))
		{
			$title = sanitize($_POST['title'], 80 , 'S'); //sanitize, 80 chars max
		}
		if (IsSet ($_POST['order']))
		{
			$order = intval($_POST['order']);
		}
		if (IsSet ($_POST['invisible']))
		{
			$invisible = sanitize($_POST['invisible'], 3 , 'A');
		}
		if (IsSet ($_POST['check']))
		{
			$check = intval($_POST['check']);
		}

		if (IsSet ($_POST['newcontent']))
		{
			$newcontent = sanitize($_POST['newcontent'], 0, 'H');	//allow html tags but filter eg. javascript
		}
		
		if (IsSet ($_POST['approve']))
		{
			$approve = intval($_POST['approve']);
		}
		if ($title != "")
		{
			mysqli_query($db,"UPDATE $table_studentpages SET title = '$title' WHERE studentid = '" . $save_page . "'");
		}
		if ($newcontent != "")
		{
			$query = "SELECT dir_number, pcheck, send_email, change_date, newcontent FROM $table_studentpages WHERE studentid = '" . $save_page . "'";
			$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING);  //get check bit, email bit and change date
			$project_id = mysqli_result($result, 0, 0);
			$check = mysqli_result($result, 0, 1);
			$send_email = mysqli_result($result, 0, 2);
			$change_date = mysqli_result($result, 0, 3);
			$old_new_content = mysqli_result($result, 0, 4);
			unset ($query);
			unset ($result);
		}
		mysqli_query($db,"UPDATE $table_studentpages SET invisible = '$invisible' WHERE studentid = '" . $save_page . "'");
		$d = date("Y-m-d");
	}

	if ((IsSet ($save_page)) AND (($_SESSION['user_type'] == 2) or ($_SESSION['user_type'] == 22)))
	{
		if($old_new_content != "")
		{
			//the student or projectpage has not been approved , we need to save newcontent
			mysqli_query($db,"UPDATE $table_studentpages SET newcontent = '$newcontent' WHERE studentid = '" . $save_page . "'");
		}
		else
		{
			mysqli_query($db,"UPDATE $table_studentpages SET content = '$newcontent' WHERE studentid = '" . $save_page . "'");
		}

		mysqli_query($db,"UPDATE $table_studentpages SET pcheck = '$check', sort = '$order', change_date='$d' WHERE studentid = '" . $save_page . "'");
		
		print "<script type=\"text/javascript\">
				alert (\"" . $sas_lang['student_page_save'] . "\");
				window.close();
				</script>";
		exit;
	}
	elseif ((IsSet ($save_page)) and (($_SESSION['user_type'] == 1) or ($_SESSION['user_type'] == 21)))
	{
		require ("../../core/class.phpmailer.php"); //use the phpmailer class

		if ($newcontent != "")
		{
			$query = "SELECT project, name FROM $table_classes WHERE dir_number = '" . $project_id . "'"; //are we a project or pupil
			$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING); 

			if (mysqli_num_rows($result) > 0)
			{
				//project
				$project = mysqli_result($result, 0, 0);
				$class_name = mysqli_result($result, 0, 1); //get the student class/project name
				$query = "SELECT email FROM $table_users 
						WHERE (project LIKE '%,$project,%' OR project like '$project,%' OR project like '%,$project' OR project like '$project')
						AND (type = 2 OR type = 22) AND email != ''";
			}
			else
			{
				//pupils page.
				$query = "SELECT email FROM $table_users 
						WHERE (class LIKE '%,$class,%' OR class like '$class,%' OR class like '%,$class' OR class like '$class')
						AND (type = 2 OR type = 22) AND email != ''";
			}
			//get the teachers email
			$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING); 
			if (mysqli_num_rows($result) > 0)
			{
				while ($teacher_email_list = mysqli_fetch_array($result))
				{
					$teacher_email .= $teacher_email_list[0] . ",";
				}
				$teacher_email = substr($teacher_email, 0, -1); //strip last comma
			}
			unset ($query);
			unset ($result);
			if ($title != "")
			{
				mysqli_query($db,"UPDATE $table_studentpages SET title='$title', change_date='$d', approved = '' WHERE studentid='" . $save_page . "'");
			}

			if ($check == "0")	//no approval needed, just write content to table.
			{
				mysqli_query($db,"UPDATE $table_studentpages SET content = '$newcontent' WHERE studentid = '" . $save_page . "'");
			}
			else
			{
				if (($teacher_email != "") and ($change_date < $d) AND ($approve == 1))
				{
					$msg = "<html><body>";
					$msg .= nl2br($sas_lang['student_email_message1'] . "\n" . $student_name . "\n" . $sas_lang['email'] . " : " . $student_email);
					$msg = str_replace("%title%", $title, $msg);

					if ($project == 1) //we have a project here
					{
						$type = $sas_lang['student_project'];
					}
					else
					{
						$type = $sas_lang['student'];
					}
					$msg = str_replace("%type%", $type, $msg);
					$msg .= "</body></html>";
					$mail = new PHPMailer();
					$mail->CharSet = $sas_lang['lang_charset'] ;
					$mail->From = $sas_config['email']; //site email address
					$mail->FromName = $sitename;
					$mail->Subject = $sas_lang[student_page_check] . " " . $student_name;
					$mail->Body = $msg;
					$mail->IsHTML(true);
					$mail->AddAddress($teacher_email); //add email address teacher.
					$mail->Send();
				}
				mysqli_query($db,"UPDATE $table_studentpages SET newcontent='$newcontent' WHERE studentid='$save_page'");
			}
			if (($teacher_email != "") and ($send_email == "1") and ($change_date < $d))
			{ //get the page and section number for the pupilpages
				$result = mysqli_query($db,"SELECT id, section FROM $table_pages WHERE name='" . $class_name . "' AND module='sn_studentpages/viewpage2.php'");
				if (mysqli_num_rows($result) > 0)
				{
					$student_pages = mysqli_result($result, 0, 0);
					$student_section = mysqli_result($result, 0, 1);
				}
				else
				{
					$result = mysqli_query($db,"SELECT id, section FROM $table_pages WHERE module='sn_studentpages/viewpage.php'");
					$student_pages = mysqli_result($result, 0, 0);
					$student_section = mysqli_result($result, 0, 1);
				}
				if (mysqli_num_rows($result) > 0)
				{
					$link = "<a href=\"" . $sas_config['url'] . "index.php?section=$student_section&page=$student_pages&page_id=$save_page\">" . $sas_config['url'] . "index.php?section=$student_section&page=$student_pages&page_id=$save_page</a>";
				}
				$msg = "<html><body>" . $sas_lang['student_email_message2'] . "\n" . $student_name . "<br>" . $sas_lang['email'] . " : " . $student_email;
				$msg = nl2br($msg);
				$msg = str_replace("%title%", $title, $msg);
				$msg = str_replace("%link%", $link, $msg);
				$msg .= "</body></html>";
				$mail = new PHPMailer();
				$mail->From = $sas_config['email']; //site email address
				$mail->FromName = $sitename;
				$mail->Subject = $sas_lang['student_pages'] . ": " . $student_name . " " . $sas_lang['title'] . ": " . $title;
				$mail->Body = $msg;
				$mail->IsHTML(true);
				$mail->AddAddress($teacher_email); //add email address teacher.
				$mail->Send();
			}
			mysqli_query($db,"UPDATE $table_studentpages SET change_date='$d', sort='$order' WHERE studentid = '" . $save_page . "'");
			//update the last change date in pages table
			if ($project == 1) //we have a project here
			{
				mysqli_query($db,"UPDATE $table_pages SET lastupdate='$d' WHERE module = 'sn_studentpages/viewproject.php' AND name = '$class_name'");
			}
			else
			{
				mysqli_query($db,"UPDATE $table_pages SET lastupdate='$d' WHERE module = 'sn_studentpages/viewpage.php'");
				mysqli_query($db,"UPDATE $table_pages SET lastupdate='$d' WHERE module = 'sn_studentpages/viewpage2.php' AND name = '" . $class_name . "'");
			}
		}

		print "<script type=\"text/javascript\">
					alert (\"" . $sas_lang['student_page_save'] . "\");
					window.close();
					</script>";
		exit;
	}

	$server_path = $sas_config['serverpath'];
	$user_path = $sas_config['user_path'];
	$media = $sas_config['media_dir'];

	//get all the info about the page
	$query = "SELECT dir_number, approved, title, newcontent, invisible, sort, pcheck, content FROM $table_studentpages WHERE studentid = '" . $edit_page . "'";
	$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING);  //get the  project id!
	
	if (mysqli_num_rows($result) > 0)	//existing page
	{
		$dir_number = mysqli_result($result, 0, 'dir_number');
		$userid_in_use = mysqli_result($result, 0, 'approved');
	
		//get class id and name
		$query1 = "SELECT id, name FROM $table_classes WHERE dir_number = '" . $dir_number . "'";	
		$result1 = mysqli_query($db,$query1) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query1 . '".',E_USER_WARNING);  //check if student has a project assigned!
		
		if (mysqli_num_rows($result1) > 0)
		{
			$project_id = mysqli_result($result1, 0);
			$project_page_id = mysqli_result($result1, 0);
		}
		else
		{
			$project_id = " ";
		}
	
		$ses_table = $dbprefix . "sessions";
		$str_len = strlen($userid_in_use);
		$ses_value = "%userid|s:$str_len:\"" . $userid_in_use . "\";%";
		$result1 = mysqli_query($db,"SELECT ses_id FROM $ses_table WHERE ses_value like '" . $ses_value . "'");
	
		//check to see if userid holding the page still has a session
		if (mysqli_num_rows($result1) == 0)
		{
			mysqli_query($db,"UPDATE $table_studentpages SET approved = '' WHERE studentid = '" . $edit_page . "'");
			$userid_in_use = ''; //no session , reset approved field.
		}
		if (($userid_in_use == '') OR ($userid_in_use == $_SESSION['userid'])) //nobody is holding the page
		{
			$title = mysqli_result($result, 0, 'title');
			$content = mysqli_result($result, 0, 'newcontent');
			$invisible = mysqli_result($result, 0, 'invisible');
			$order = mysqli_result($result, 0, 'sort');
			$pcheck = mysqli_result($result, 0, 'pcheck');
			
			if ($content == "")
			{
				$content = mysqli_result($result, 0, 'content');
			}
			unset ($query);
			unset ($result);
			
			mysqli_query($db,"UPDATE $table_studentpages SET approved = '$_SESSION[userid]' WHERE studentid = '" . $edit_page . "'");
		}
		else
		{
			//see who does
			$query = "SELECT name FROM $table_users WHERE id = '" . $userid_in_use . "'";
			$result = mysqli_query($db,$query);
			$pupil_name = mysqli_result($result, 0);
			$msg = str_replace("%user_name%", $pupil_name, $sas_lang['page_in_use']);
			print $msg;
			print "<br><br><input type=\"button\" value=\"" . $sas_lang['goback'] . "\" name=\"backbutton\" 
				onClick=\"javascript:window.close();\" class=\"backbutton\"></span><br>";
			exit;
		}
			
		$template_path = $server_path . $user_path . "/" . $media . "/templates";
		
		if (IsSet ($_GET['template']))
		{
			$template = preg_replace('/[^a-zA-Z0-9\-_.]*/' , '', $_GET['template']);
			$pos = strrpos($template, ".");	//get last point
			$template = substr($template,0,$pos);	//remove extention, be sure it is a html file
			$filename = $template_path . "/" . $template . ".html";
	
			if (file_exists($filename))
			{
				$handle = fopen($filename, "r");
				$content = fread($handle, filesize($filename));
				fclose($handle);
			}
		}
	
		print "<html><head><title></title>
				<script type=\"text/javascript\" src=\"ckeditor.js\"></script>
				<link rel=\"StyleSheet\" href=\"../../interface/style.css\" type=\"text/css\" />
				<style type=\"text/css\" />	
				button span {  
					background:url(../../graphics/bg_button.gif) no-repeat 0 0; 
				}	
				button em { 
					background:url(../../graphics/bg_button.gif) no-repeat 100% 0; 
				}	

				button.first span { 
					background:url(../../graphics/bg_button.gif) no-repeat 0 -102px; 
				}	
				button.first em { 
					background:url(../../graphics/bg_button.gif) no-repeat 100% -102px; 
				}		

				button:hover span, button.over span { 
					background:url(../../graphics/bg_button.gif) no-repeat 0 -24px; 
				}	
				button:hover em, button.over em {  
					background:url(../../graphics/bg_button.gif) no-repeat 100% -24px; 
				}
				</style>
				</head><body>";
	
		$_SESSION['editpage'] = $edit_page; //used for image browser plugin to go to the right (project) directory
		$_SESSION['dir_number'] = $dir_number;
	
		print "<form method=\"post\" name=\"form\" action=\"studenteditor.php?save_page=$edit_page\">
				<table class=\"ToolBar\" id=\"idToolbar\" cellSpacing=\"0\" cellPadding=\"0\" width=\"100%\" border=\"0\">
				<tbody>
				<tr style=\"background:ButtonFace\">
				<td colspan=\"18\" height=\"28\" valign=\"bottom\">";
	
		print "&nbsp;" . $sas_lang['title'] . ":&nbsp;</span>
			  <input type=\"text\" name=\"title\" size=\"40\" value=\"$title\">
			  &nbsp;" . $sas_lang['order'] . ":&nbsp;
			  <input type=\"text\" name=\"order\" size=\"4\" value=\"$order\">";
	
		if (is_dir($template_path))
		{
			print "&nbsp;&nbsp;" . $sas_lang['template'] . ":&nbsp;&nbsp;<select size=\"1\" name=\"template\" 
				onchange=\"parent.location.href='studenteditor.php?option=editpage&editpage=$edit_page&template=' + this.options[this.selectedIndex].value\">>\n";
			$dir_handle = @ opendir($template_path);
			print "<option value=\"" . $sas_lang['choose_one'] . "\">" . $sas_lang['choose_one'] . "</option>";
			while ($file = readdir($dir_handle))
			{
				if (preg_match('/.html/', $file))
				{
					$file_array[] = $file ;
					//order the files naterually
					$array_lowercase = array_map('strtolower', $file_array); //convert to lowercase first
					array_multisort($array_lowercase, SORT_ASC, SORT_REGULAR, $file_array); //do the sorting
				}
			}
		closedir($dir_handle);
		
			foreach($file_array as $value)
			{
				echo "<option value=\"$value\">$value</option>";
			}
			
		print "</select><br />";
		}
		if ($invisible == 1)
		{
			print "&nbsp;&nbsp;<input type=\"checkbox\" name=\"invisible\" value=\"1\" checked>" . $sas_lang['invisible'];
		}
		else
		{
			print "&nbsp;&nbsp;<input type=\"checkbox\" name=\"invisible\" value=\"1\">" . $sas_lang['invisible'];
		}
		
		$theme_css = $sas_config['url'] . "starnet/themes/" . $sas_config['theme'] . "/style.css";
		
		print "</tr><tr valign=\"center\"><td>";
		
		$height = $sas_config['htmlarea_editor_rows'] * 20;
		$fck_lang = strtolower($sas_config['language']);
		print "<textarea cols=\"80\" id=\"editor_v2\" name=\"newcontent\" rows=\"".$sas_config['htmlarea_editor_rows']."\">$content</textarea>";
?>
	<script type="text/javascript">
	//<![CDATA[

		CKEDITOR.replace( 'editor_v2',
			{
				language : '<?php echo $fck_lang ?>',
				font_names: '<?php load_webfont_names(); ?>',
				contentsCss : ['<?php echo $theme_css ?>'<?php load_webfonts(); ?>],
				height : <?php echo $height ?>,
				width : <?php echo $sas_config['editor_width']; ?>,
				toolbar : 'Full',
				filebrowserBrowseUrl : 'filemanager/browser.php?type=link',
				filebrowserImageBrowseUrl : 'filemanager/browser.php?type=image',
				filebrowserFlashBrowseUrl : 'filemanager/browser.php?type=flash',
				filebrowserFLVPlayerBrowseUrl : 'filemanager/browser.php?type=flash',
				customConfig: "sas_config.js"

			});

	//]]>
	</script>
<?php
	
		print "</td><tr></table>";
		print "<table width=\"100%\" border=\"0\"><tr>";
		
		//teacher extar's
		if ((($_SESSION['user_type'] == 2) or ($_SESSION['user_type'] == 22)) AND (!in_array($project_page_id, $project_array)))
		{
			print "<td width=\"30%\">" . $sas_lang['page_on'] . " &nbsp;&nbsp;&nbsp;" . $sas_lang['teacher_pages'] . "</td>";
			if ($pcheck == "1")
			{
				print "<td><input type=\"radio\" value=\"1\" name=\"check\" checked></td>";
				print "<td width=\"30%\" align=\"right\">&nbsp;&nbsp;&nbsp;" . $sas_lang['student_pages'] . "</td>";
				print "<td><input type=\"radio\" name=\"check\" value=\"0\"></td>";
				print "<td width=\"30%\" align=\"right\">&nbsp;&nbsp;&nbsp;" . $sas_lang['both'] . "</td>";
				print "<td><input type=\"radio\" name=\"check\" value=\"2\"></td>";
			}
			elseif ($pcheck == "0")
			{
				print "<td><input type=\"radio\" value=\"1\" name=\"check\"></td>";
				print "<td width=\"30%\" align=\"right\">&nbsp;&nbsp;&nbsp;" . $sas_lang['student_pages'] . "</td>";
				print "<td><input type=\"radio\" name=\"check\" value=\"0\" checked></td>";
				print "<td width=\"30%\" align=\"right\">&nbsp;&nbsp;&nbsp;" . $sas_lang['both'] . "</td>";
				print "<td><input type=\"radio\" name=\"check\" value=\"2\"></td>";
			}
			else
			{
				print "<td><input type=\"radio\" value=\"1\" name=\"check\"></td>";
				print "<td width=\"30%\" align=\"right\">&nbsp;&nbsp;&nbsp;" . $sas_lang['student_pages'] . "</td>";
				print "<td><input type=\"radio\" name=\"check\" value=\"0\"></td>";
				print "<td width=\"30%\" align=\"right\">&nbsp;&nbsp;&nbsp;" . $sas_lang['both'] . "</td>";
				print "<td><input type=\"radio\" name=\"check\" value=\"2\" checked></td>";
			}
	
			print "<tr>";
		}
		
		//pupil
		if (($_SESSION['user_type'] == 1) AND ($pcheck == "1"))
		{
			print "<td>" . $sas_lang['student_publish_page'] . "</td>";
			print "<td>" . $sas_lang['no'] . "<input type=\"radio\" value=\"0\" name=\"approve\" checked>&nbsp;</td>";
			print "<td>" . $sas_lang['yes'] . "<input type=\"radio\" name=\"approve\" value=\"1\"></td></tr>";
		}
	
		print "<tr><td align=\"right\" colspan=\"6\"><button onclick=\"javascript:window.close();\" type=\"button\" class=\"button\"><em><span>".$sas_lang['goback']."</span></em></button>";
		print "<button type=\"submit\" class=\"button\"><em><span>".$sas_lang['save']."</span></em></button></td>
				</tr></table>";
	}
}
?>
</body>
</html>